Index: trunk/LMDZ.GENERIC/libf/phystd/surfini.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/surfini.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/surfini.F	(revision 787)
@@ -1,3 +1,7 @@
-      SUBROUTINE surfini(ngrid,qsurf,psolaralb)
+      SUBROUTINE surfini(ngrid,nq,qsurf,psolaralb)
+
+      USE surfdat_h
+      USE tracer_h
+
       IMPLICIT NONE
 c=======================================================================
@@ -11,11 +15,10 @@
 #include "dimensions.h"
 #include "dimphys.h"
-#include "surfdat.h"
 #include "callkeys.h"
-#include "tracer.h"
 c
       INTEGER ngrid,ig,icap
+      INTEGER nq
       REAL  piceco2(ngrid),psolaralb(ngrid)
-      REAL qsurf(ngrid,nqmx) !tracer on surface (kg/m2)
+      REAL qsurf(ngrid,nq) !tracer on surface (kg/m2)
 
       EXTERNAL ISMIN,ISMAX
@@ -42,5 +45,5 @@
 !      DO ig=1,ngrid
 c	 IF (water) THEN 
-c	   if (qsurf(ig,nqmx).gt.0.005) then
+c	   if (qsurf(ig,nq).gt.0.005) then
 c             psolaralb(ig,1) = 0.4
 c             psolaralb(ig,2) = 0.4 
Index: trunk/LMDZ.GENERIC/libf/phystd/tabfi.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/tabfi.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/tabfi.F	(revision 787)
@@ -1,4 +1,4 @@
 c=======================================================================
-      SUBROUTINE tabfi(nid,Lmodif,tab0,day_ini,lmax,p_rad,
+      SUBROUTINE tabfi(ngrid,nid,Lmodif,tab0,day_ini,lmax,p_rad,
      .                 p_omeg,p_g,p_cpp,p_mugaz,p_daysec,time)
 c=======================================================================
@@ -46,4 +46,8 @@
       use ioipsl_getincom 
 
+      USE surfdat_h
+      use comsoil_h
+      USE comgeomfi_h
+
       implicit none
  
@@ -51,8 +55,5 @@
 #include "dimphys.h"
 #include "comcstfi.h"
-#include "comgeomfi.h"
 #include "planete.h"
-#include "surfdat.h"
-#include "comsoil.h"
 #include "netcdf.inc"
 #include "callkeys.h"
@@ -61,4 +62,6 @@
 c   Declarations
 c-----------------------------------------------------------------------
+
+      INTEGER ngrid
 
 c Arguments
@@ -104,7 +107,7 @@
 c  Initialization of some physical constants
 c informations on physics grid
-      if(ngridmx.ne.tab_cntrl(tab0+1)) then
-         print*,'tabfi: WARNING !!! tab_cntrl(tab0+1).ne.ngridmx'
-         print*,tab_cntrl(tab0+1),ngridmx
+      if(ngrid.ne.tab_cntrl(tab0+1)) then
+         print*,'tabfi: WARNING !!! tab_cntrl(tab0+1).ne.ngrid'
+         print*,tab_cntrl(tab0+1),ngrid
       endif
       lmax = nint(tab_cntrl(tab0+2))
@@ -168,5 +171,5 @@
       write(*,*) 'Reading tab_cntrl when calling tabfi before changes'
       write(*,*) '*****************************************************'
-      write(*,5) '(1)      = ngridmx?',tab_cntrl(tab0+1),float(ngridmx)
+      write(*,5) '(1)        = ngrid?',tab_cntrl(tab0+1),float(ngrid)
       write(*,5) '(2)            lmax',tab_cntrl(tab0+2),float(lmax)
       write(*,5) '(3)         day_ini',tab_cntrl(tab0+3),float(day_ini)
@@ -490,5 +493,5 @@
       write(*,*) 'Reading tab_cntrl when calling tabfi AFTER changes'
       write(*,*) '*****************************************************'
-      write(*,5) '(1)      = ngridmx?',tab_cntrl(tab0+1),float(ngridmx)
+      write(*,5) '(1)        = ngrid?',tab_cntrl(tab0+1),float(ngrid)
       write(*,5) '(2)            lmax',tab_cntrl(tab0+2),float(lmax)
       write(*,5) '(3)         day_ini',tab_cntrl(tab0+3),float(day_ini)
Index: trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90	(revision 787)
@@ -1,5 +1,8 @@
-      subroutine totalcloudfrac(rneb,totalrneb,pplev,pq,tau)
+      subroutine totalcloudfrac(ngrid,nq,rneb,totalrneb,pplev,pq,tau)
 
       use watercommon_h
+      use comdiurn_h
+      USE comgeomfi_h
+      USE tracer_h
       implicit none
 
@@ -19,17 +22,14 @@
 #include "dimphys.h"
 #include "comcstfi.h"
-#include "tracer.h"
-#include "fisice.h"
-#include "comgeomfi.h"
-#include "comdiurn.h"
 #include "callkeys.h"
 
+      integer ngrid, nq
 
-      real rneb(ngridmx,nlayermx)             ! cloud fraction     
-      real pplev(ngridmx,nlayermx+1)
-      real pq(ngridmx,nlayermx,nqmx)
-      real tau(ngridmx,nlayermx)
+      real rneb(ngrid,nlayermx)             ! cloud fraction     
+      real pplev(ngrid,nlayermx+1)
+      real pq(ngrid,nlayermx,nq)
+      real tau(ngrid,nlayermx)
 
-      real totalrneb(ngridmx)                 ! total cloud fraction 
+      real totalrneb(ngrid)                 ! total cloud fraction 
       real, dimension(nlayermx+1) :: masse
       integer, parameter          :: recovery=7
@@ -50,5 +50,5 @@
 
 
-      do ig=1,ngridmx
+      do ig=1,ngrid
          totalrneb(ig) = 0.
 
Index: trunk/LMDZ.GENERIC/libf/phystd/tracer_h.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/tracer_h.F90	(revision 787)
+++ trunk/LMDZ.GENERIC/libf/phystd/tracer_h.F90	(revision 787)
@@ -0,0 +1,51 @@
+
+       module tracer_h
+
+       implicit none
+
+       character*20, DIMENSION(:), ALLOCATABLE :: noms   ! name of the tracer
+       real, DIMENSION(:), ALLOCATABLE :: mmol     ! mole mass of tracer (g/mol-1) 
+       real, DIMENSION(:), ALLOCATABLE :: radius   ! dust and ice particle radius (m)
+       real, DIMENSION(:), ALLOCATABLE :: rho_q    ! tracer densities (kg.m-3)
+       real, DIMENSION(:), ALLOCATABLE :: qext     ! Single Scat. Extinction coeff at 0.67 um
+       real, DIMENSION(:), ALLOCATABLE :: alpha_lift  ! saltation vertical flux/horiz flux ratio (m-1)
+       real, DIMENSION(:), ALLOCATABLE :: alpha_devil ! lifting coeeficient by dust devil
+       real, DIMENSION(:), ALLOCATABLE :: qextrhor ! Intermediate for computing opt. depth from q
+
+      real varian      ! Characteristic variance of log-normal distribution
+      real r3n_q     ! used to compute r0 from number and mass mixing ratio
+      real rho_dust     ! Mars dust density (kg.m-3)
+      real rho_ice     ! Water ice density (kg.m-3)
+      real rho_co2     ! CO2 ice density (kg.m-3)
+      real ref_r0        ! for computing reff=ref_r0*r0 (in log.n. distribution)
+
+! tracer indexes: these are initialized in initracer and should be 0 if the
+!                 corresponding tracer does not exist
+      ! dust
+      integer, DIMENSION(:), ALLOCATABLE :: igcm_dustbin ! for dustbin 'dust' tracers
+      ! dust, special doubleq case
+      integer :: igcm_dust_mass   ! dust mass mixing ratio (for transported dust)
+      integer :: igcm_dust_number ! dust number mixing ratio (transported dust)
+      ! water
+      integer :: igcm_h2o_vap ! water vapour
+      integer :: igcm_h2o_ice ! water ice
+      ! chemistry:
+      integer :: igcm_co2
+      integer :: igcm_co
+      integer :: igcm_o
+      integer :: igcm_o1d
+      integer :: igcm_o2
+      integer :: igcm_o3
+      integer :: igcm_h
+      integer :: igcm_h2
+      integer :: igcm_oh
+      integer :: igcm_ho2
+      integer :: igcm_h2o2
+      integer :: igcm_n2
+      integer :: igcm_ar
+      ! other tracers
+      integer :: igcm_ar_n2 ! for simulations using co2 +neutral gaz
+      integer :: igcm_co2_ice ! CO2 ice 
+
+       end module tracer_h
+
Index: trunk/LMDZ.GENERIC/libf/phystd/turbdiff.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/turbdiff.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/turbdiff.F90	(revision 787)
@@ -9,4 +9,7 @@
       use watercommon_h, only : RLVTT, T_h2O_ice_liq, RCPD, mx_eau_sol,Psat_water
       use radcommon_h, only : sigma
+      USE surfdat_h
+      USE comgeomfi_h
+      USE tracer_h
 
       implicit none
@@ -43,9 +46,4 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "surfdat.h"
-#include "comgeomfi.h"
-#include "tracer.h"
-
-#include "watercap.h"
 
 !     arguments
@@ -84,23 +82,23 @@
       integer ilev,ig,ilay,nlev
 
-      REAL z4st,zdplanck(ngridmx)
-      REAL zkv(ngridmx,nlayermx+1),zkh(ngridmx,nlayermx+1)
-      REAL zcdv(ngridmx),zcdh(ngridmx)
-      REAL zcdv_true(ngridmx),zcdh_true(ngridmx)
-      REAL zu(ngridmx,nlayermx),zv(ngridmx,nlayermx)
-      REAL zh(ngridmx,nlayermx),zt(ngridmx,nlayermx)
-      REAL ztsrf(ngridmx)
-      REAL z1(ngridmx),z2(ngridmx)
-      REAL zmass(ngridmx,nlayermx)
-      REAL zfluxv(ngridmx,nlayermx),zfluxt(ngridmx,nlayermx),zfluxq(ngridmx,nlayermx)
-      REAL zb0(ngridmx,nlayermx)
-      REAL zExner(ngridmx,nlayermx),zovExner(ngridmx,nlayermx)
-      REAL zcv(ngridmx,nlayermx),zdv(ngridmx,nlayermx)  !inversion coefficient for winds
-      REAL zct(ngridmx,nlayermx),zdt(ngridmx,nlayermx)  !inversion coefficient for temperature
-      REAL zcq(ngridmx,nlayermx),zdq(ngridmx,nlayermx)  !inversion coefficient for tracers
+      REAL z4st,zdplanck(ngrid)
+      REAL zkv(ngrid,nlayermx+1),zkh(ngrid,nlayermx+1)
+      REAL zcdv(ngrid),zcdh(ngrid)
+      REAL zcdv_true(ngrid),zcdh_true(ngrid)
+      REAL zu(ngrid,nlayermx),zv(ngrid,nlayermx)
+      REAL zh(ngrid,nlayermx),zt(ngrid,nlayermx)
+      REAL ztsrf(ngrid)
+      REAL z1(ngrid),z2(ngrid)
+      REAL zmass(ngrid,nlayermx)
+      REAL zfluxv(ngrid,nlayermx),zfluxt(ngrid,nlayermx),zfluxq(ngrid,nlayermx)
+      REAL zb0(ngrid,nlayermx)
+      REAL zExner(ngrid,nlayermx),zovExner(ngrid,nlayermx)
+      REAL zcv(ngrid,nlayermx),zdv(ngrid,nlayermx)  !inversion coefficient for winds
+      REAL zct(ngrid,nlayermx),zdt(ngrid,nlayermx)  !inversion coefficient for temperature
+      REAL zcq(ngrid,nlayermx),zdq(ngrid,nlayermx)  !inversion coefficient for tracers
       REAL zcst1
       REAL zu2!, a
-      REAL zcq0(ngridmx),zdq0(ngridmx)
-      REAL zx_alf1(ngridmx),zx_alf2(ngridmx)
+      REAL zcq0(ngrid),zdq0(ngrid)
+      REAL zx_alf1(ngrid),zx_alf2(ngrid)
 
       LOGICAL firstcall
@@ -111,10 +109,10 @@
 !     -------
       INTEGER iq
-      REAL zq(ngridmx,nlayermx,nqmx)
-      REAL zqnoevap(ngridmx,nlayermx) !special for water case to compute where evaporated water goes.
-      REAL pdqevap(ngridmx,nlayermx) !special for water case to compute where evaporated water goes.
-      REAL zdmassevap(ngridmx)
-      REAL rho(ngridmx)         ! near-surface air density
-      REAL qsat(ngridmx),psat(ngridmx)
+      REAL zq(ngrid,nlayermx,nq)
+      REAL zqnoevap(ngrid,nlayermx) !special for water case to compute where evaporated water goes.
+      REAL pdqevap(ngrid,nlayermx) !special for water case to compute where evaporated water goes.
+      REAL zdmassevap(ngrid)
+      REAL rho(ngrid)         ! near-surface air density
+      REAL qsat(ngrid),psat(ngrid)
       DATA firstcall/.true./
       REAL kmixmin
@@ -122,5 +120,5 @@
 !     Variables added for implicit latent heat inclusion
 !     --------------------------------------------------
-      real dqsat(ngridmx), qsat_temp1, qsat_temp2,psat_temp
+      real dqsat(ngrid), qsat_temp1, qsat_temp2,psat_temp
 
       integer, save :: ivap, iliq, iliq_surf,iice_surf ! also make liq for clarity on surface...
@@ -241,5 +239,5 @@
 !     ------------------------------------------------------ 
 
-      call vdif_kc(ptimestep,g,pzlev,pzlay,pu,pv,zh,zcdv_true,pq2,zkv,zkh) !JL12 why not call vdif_kc with updated winds and temperature 
+      call vdif_kc(ngrid,ptimestep,g,pzlev,pzlay,pu,pv,zh,zcdv_true,pq2,zkv,zkh) !JL12 why not call vdif_kc with updated winds and temperature 
 
 !     Adding eddy mixing to mimic 3D general circulation in 1D
@@ -262,5 +260,5 @@
  
 !JL12 calculate the flux coefficients (tables multiplied elements by elements)
-      zfluxv(1:ngridmx,1:nlayermx)=zkv(1:ngridmx,1:nlayermx)*zb0(1:ngridmx,1:nlayermx)
+      zfluxv(1:ngrid,1:nlayermx)=zkv(1:ngrid,1:nlayermx)*zb0(1:ngrid,1:nlayermx)
       
 !-----------------------------------------------------------------------
@@ -358,7 +356,6 @@
 !     JL12 calculate the flux coefficients (tables multiplied elements by elements)
 !     ---------------------------------------------------------------
-      zfluxq(1:ngridmx,1:nlayermx)=zkh(1:ngridmx,1:nlayermx)*zb0(1:ngridmx,1:nlayermx) !JL12 we save zfluxq which doesn't need the Exner factor
-      zfluxt(1:ngridmx,1:nlayermx)=zfluxq(1:ngridmx,1:nlayermx)*zExner(1:ngridmx,1:nlayermx)
-
+      zfluxq(1:ngrid,1:nlayermx)=zkh(1:ngrid,1:nlayermx)*zb0(1:ngrid,1:nlayermx) !JL12 we save zfluxq which doesn't need the Exner factor
+      zfluxt(1:ngrid,1:nlayermx)=zfluxq(1:ngrid,1:nlayermx)*zExner(1:ngrid,1:nlayermx)
 
       DO ig=1,ngrid
@@ -404,5 +401,4 @@
 
          DO ig=1,ngrid
-
             z1(ig)=pcapcal(ig)*ptsrf(ig)+cpp*zfluxt(ig,1)*zct(ig,1)*zovExner(ig,1) &
                 + pfluxsrf(ig)*ptimestep + zdplanck(ig)*ptsrf(ig) 
@@ -434,5 +430,5 @@
 !     Calculate vertical flux from the bottom to the first layer (dust)
 !     -----------------------------------------------------------------
-         do ig=1,ngridmx  
+         do ig=1,ngrid
             rho(ig) = zb0(ig,1) /ptimestep
          end do
@@ -470,5 +466,5 @@
                   ENDDO
                else             ! general case
-                  DO ig=1,ngrid
+                  do ig=1,ngrid
                      z1(ig)=1./(zmass(ig,1)+zfluxq(ig,2)*(1.-zdq(ig,2)))
                      zcq(ig,1)=(zmass(ig,1)*zq(ig,1,iq)+zfluxq(ig,2)*zcq(ig,2)+(-pdqsdif(ig,iq))*ptimestep)*z1(ig)
@@ -500,5 +496,5 @@
             
                ! compute evaporation efficiency
-               do ig = 1, ngrid
+               do ig=1,ngrid
                   if(rnat(ig).eq.1)then
                      dryness(ig)=pqsurf(ig,iliq_surf)+pqsurf(ig,iice_surf) 
@@ -509,5 +505,4 @@
 
                do ig=1,ngrid
-
                 ! Calculate the value of qsat at the surface (water)
                 call Psat_water(ptsrf(ig),pplev(ig,1),psat(ig),qsat(ig))
@@ -526,5 +521,5 @@
                   zdq(ig,nlay)=zfluxq(ig,nlay)*z1(ig)
                enddo 
-            
+          
                do ilay=nlay-1,2,-1
                   do ig=1,ngrid
@@ -658,5 +653,5 @@
             ENDDO
 
-            DO ig=1,ngrid
+            do ig=1,ngrid
                z1(ig)=1./(zmass(ig,1)+zfluxq(ig,2)*(1.-zdq(ig,2)))
                zcq(ig,1)=(zmass(ig,1)*zqnoevap(ig,1)+zfluxq(ig,2)*zcq(ig,2))*z1(ig)
@@ -692,5 +687,5 @@
       enddo
       
-      DO ig=1,ngrid  ! computing sensible heat flux (atm => surface)
+      DO ig=1,ngrid ! computing sensible heat flux (atm => surface)
 	 sensibFlux(ig)=cpp*zfluxt(ig,1)/ptimestep*(zt(ig,1)*zovExner(ig,1)-ztsrf(ig))
       ENDDO
@@ -710,5 +705,5 @@
                enddo
             enddo
-	    do ig=1,ngrid
+            do ig=1,ngrid
 	       zdmassevap(ig)=SUM(pdqevap(ig,:)*zmass(ig,:))*ptimestep
 	    end do	    
Index: trunk/LMDZ.GENERIC/libf/phystd/vdif_kc.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/vdif_kc.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/vdif_kc.F	(revision 787)
@@ -1,3 +1,3 @@
-      SUBROUTINE vdif_kc(dt,g,zlev,zlay,u,v,teta,cd,q2,km,kn)
+      SUBROUTINE vdif_kc(ngrid,dt,g,zlev,zlay,u,v,teta,cd,q2,km,kn)
       IMPLICIT NONE
 c.......................................................................
@@ -27,14 +27,15 @@
 c 
 c.......................................................................
+      INTEGER ngrid
       REAL dt,g
-      REAL zlev(ngridmx,nlayermx+1)
-      REAL zlay(ngridmx,nlayermx)
-      REAL u(ngridmx,nlayermx)
-      REAL v(ngridmx,nlayermx)
-      REAL teta(ngridmx,nlayermx)
-      REAL cd(ngridmx)
-      REAL q2(ngridmx,nlayermx+1)
-      REAL km(ngridmx,nlayermx+1)
-      REAL kn(ngridmx,nlayermx+1)
+      REAL zlev(ngrid,nlayermx+1)
+      REAL zlay(ngrid,nlayermx)
+      REAL u(ngrid,nlayermx)
+      REAL v(ngrid,nlayermx)
+      REAL teta(ngrid,nlayermx)
+      REAL cd(ngrid)
+      REAL q2(ngrid,nlayermx+1)
+      REAL km(ngrid,nlayermx+1)
+      REAL kn(ngrid,nlayermx+1)
 c.......................................................................
 c
@@ -49,8 +50,8 @@
 c
 c.......................................................................
-      INTEGER nlay,nlev,ngrid
-      REAL unsdz(ngridmx,nlayermx)
-      REAL unsdzdec(ngridmx,nlayermx+1)
-      REAL q(ngridmx,nlayermx+1)
+      INTEGER nlay,nlev
+      REAL unsdz(ngrid,nlayermx)
+      REAL unsdzdec(ngrid,nlayermx+1)
+      REAL q(ngrid,nlayermx+1)
 c.......................................................................
 c
@@ -62,5 +63,5 @@
 c
 c.......................................................................
-      REAL kmpre(ngridmx,nlayermx+1)
+      REAL kmpre(ngrid,nlayermx+1)
       REAL qcstat
       REAL q2cstat
@@ -70,5 +71,5 @@
 c
 c.......................................................................
-      REAL long(ngridmx,nlayermx+1)
+      REAL long(ngrid,nlayermx+1)
 c.......................................................................
 c
@@ -93,8 +94,8 @@
       REAL mcstat
       REAL m2cstat
-      REAL m(ngridmx,nlayermx+1)
-      REAL mpre(ngridmx,nlayermx+1)
-      REAL m2(ngridmx,nlayermx+1)
-      REAL n2(ngridmx,nlayermx+1)
+      REAL m(ngrid,nlayermx+1)
+      REAL mpre(ngrid,nlayermx+1)
+      REAL m2(ngrid,nlayermx+1)
+      REAL n2(ngrid,nlayermx+1)
 c.......................................................................
 c
@@ -118,9 +119,9 @@
       LOGICAL gnsup
       REAL gm
-c      REAL ri(ngridmx,nlayermx+1)
-      REAL sn(ngridmx,nlayermx+1)
-      REAL snq2(ngridmx,nlayermx+1)
-      REAL sm(ngridmx,nlayermx+1)
-      REAL smq2(ngridmx,nlayermx+1)
+c      REAL ri(ngrid,nlayermx+1)
+      REAL sn(ngrid,nlayermx+1)
+      REAL snq2(ngrid,nlayermx+1)
+      REAL sm(ngrid,nlayermx+1)
+      REAL smq2(ngrid,nlayermx+1)
 c.......................................................................
 c
@@ -183,5 +184,4 @@
       PARAMETER (nlay=nlayermx)
       PARAMETER (nlev=nlayermx+1)
-      PARAMETER (ngrid=ngridmx)
 c
       PARAMETER (
@@ -209,16 +209,16 @@
 c
       DO ilev=1,nlev
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid 
         q2(igrid,ilev)=amax1(q2(igrid,ilev),q2min)
         q(igrid,ilev)=sqrt(q2(igrid,ilev))
-                                                      ENDDO
+                                                 ENDDO
       ENDDO
 c
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
       tmp1=cd(igrid)*(u(igrid,1)**2+v(igrid,1)**2)
       q2(igrid,1)=b1**(2.E+0/3.E+0)*tmp1
       q2(igrid,1)=amax1(q2(igrid,1),q2min)
       q(igrid,1)=sqrt(q2(igrid,1))
-                                                      ENDDO
+                                                 ENDDO
 c
 c.......................................................................
@@ -237,19 +237,19 @@
 c
       DO ilay=1,nlay
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
         unsdz(igrid,ilay)=1.E+0/(zlev(igrid,ilay+1)-zlev(igrid,ilay))
-                                                      ENDDO
+                                                 ENDDO
       ENDDO
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
       unsdzdec(igrid,1)=1.E+0/(zlay(igrid,1)-zlev(igrid,1))
-                                                      ENDDO
+                                                 ENDDO
       DO ilay=2,nlay
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
         unsdzdec(igrid,ilay)=1.E+0/(zlay(igrid,ilay)-zlay(igrid,ilay-1))
-                                                      ENDDO
+                                                 ENDDO
       ENDDO
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
       unsdzdec(igrid,nlay+1)=1.E+0/(zlev(igrid,nlay+1)-zlay(igrid,nlay))
-                                                      ENDDO
+                                                 ENDDO
 c
 c.......................................................................
@@ -257,5 +257,5 @@
 c.......................................................................
 c
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
       m2(igrid,1)=(unsdzdec(igrid,1)
      &                   *u(igrid,1))**2
@@ -264,9 +264,9 @@
       m(igrid,1)=sqrt(m2(igrid,1))
       mpre(igrid,1)=m(igrid,1)
-                                                      ENDDO
+                                                 ENDDO
 c
 c-----------------------------------------------------------------------
       DO ilev=2,nlev-1
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
 c-----------------------------------------------------------------------
 c
@@ -295,13 +295,13 @@
 c
 c-----------------------------------------------------------------------
-                                                      ENDDO
+                                                 ENDDO
       ENDDO
 c-----------------------------------------------------------------------
 c
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
       m2(igrid,nlev)=m2(igrid,nlev-1)
       m(igrid,nlev)=m(igrid,nlev-1)
       mpre(igrid,nlev)=m(igrid,nlev)
-                                                      ENDDO
+                                                 ENDDO
 c
 c.......................................................................
@@ -311,5 +311,5 @@
 c-----------------------------------------------------------------------
       DO ilev=2,nlev-1
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
 c-----------------------------------------------------------------------
 c
@@ -375,5 +375,5 @@
 c
 c-----------------------------------------------------------------------
-                                                      ENDDO
+                                                  ENDDO
       ENDDO
 c-----------------------------------------------------------------------
@@ -383,13 +383,13 @@
 c.......................................................................
 c
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
       kn(igrid,1)=knmin
       km(igrid,1)=kmmin
       kmpre(igrid,1)=km(igrid,1)
-                                                      ENDDO
+                                                 ENDDO
 c
 c-----------------------------------------------------------------------
       DO ilev=2,nlev-1
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
 c-----------------------------------------------------------------------
 c
@@ -401,13 +401,13 @@
 c
 c-----------------------------------------------------------------------
-                                                      ENDDO
+                                                 ENDDO
       ENDDO
 c-----------------------------------------------------------------------
 c
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
       kn(igrid,nlev)=kn(igrid,nlev-1)
       km(igrid,nlev)=km(igrid,nlev-1)
       kmpre(igrid,nlev)=km(igrid,nlev)
-                                                      ENDDO
+                                                 ENDDO
 c
 c.......................................................................
@@ -418,5 +418,5 @@
       DO 10001 ilev=2,nlev-1
 c---->
-      DO 10002 igrid=1,ngrid 
+      DO 10002 igrid=1,ngrid
 c
 c.......................................................................
@@ -539,5 +539,5 @@
 c
 c
-                                                      DO igrid=1,ngrid 
+                                                 DO igrid=1,ngrid
       kn(igrid,1)=knmin
       km(igrid,1)=kmmin
@@ -546,5 +546,5 @@
       kn(igrid,nlev)=kn(igrid,nlev-1)
       km(igrid,nlev)=km(igrid,nlev-1)
-                                                      ENDDO
+                                                 ENDDO
 
 c
Index: trunk/LMDZ.GENERIC/libf/phystd/vdifc.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/vdifc.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/vdifc.F	(revision 787)
@@ -9,4 +9,7 @@
       use watercommon_h, only : RLVTT, T_h2O_ice_liq, RCPD, mx_eau_sol
       use radcommon_h, only : sigma
+      USE surfdat_h
+      USE comgeomfi_h
+      USE tracer_h
 
       implicit none
@@ -39,9 +42,4 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "surfdat.h"
-#include "comgeomfi.h"
-#include "tracer.h"
-
-#include "watercap.h"
 
 !     arguments
@@ -78,21 +76,21 @@
       integer ilev,ig,ilay,nlev
 
-      REAL z4st,zdplanck(ngridmx)
-      REAL zkv(ngridmx,nlayermx+1),zkh(ngridmx,nlayermx+1)
-      REAL zcdv(ngridmx),zcdh(ngridmx)
-      REAL zcdv_true(ngridmx),zcdh_true(ngridmx)
-      REAL zu(ngridmx,nlayermx),zv(ngridmx,nlayermx)
-      REAL zh(ngridmx,nlayermx)
-      REAL ztsrf2(ngridmx)
-      REAL z1(ngridmx),z2(ngridmx)
-      REAL za(ngridmx,nlayermx),zb(ngridmx,nlayermx)
-      REAL zb0(ngridmx,nlayermx)
-      REAL zc(ngridmx,nlayermx),zd(ngridmx,nlayermx)
+      REAL z4st,zdplanck(ngrid)
+      REAL zkv(ngrid,nlayermx+1),zkh(ngrid,nlayermx+1)
+      REAL zcdv(ngrid),zcdh(ngrid)
+      REAL zcdv_true(ngrid),zcdh_true(ngrid)
+      REAL zu(ngrid,nlayermx),zv(ngrid,nlayermx)
+      REAL zh(ngrid,nlayermx)
+      REAL ztsrf2(ngrid)
+      REAL z1(ngrid),z2(ngrid)
+      REAL za(ngrid,nlayermx),zb(ngrid,nlayermx)
+      REAL zb0(ngrid,nlayermx)
+      REAL zc(ngrid,nlayermx),zd(ngrid,nlayermx)
       REAL zcst1
       REAL zu2!, a
-      REAL zcq(ngridmx,nlayermx),zdq(ngridmx,nlayermx)
-      REAL evap(ngridmx)
-      REAL zcq0(ngridmx),zdq0(ngridmx)
-      REAL zx_alf1(ngridmx),zx_alf2(ngridmx)
+      REAL zcq(ngrid,nlayermx),zdq(ngrid,nlayermx)
+      REAL evap(ngrid)
+      REAL zcq0(ngrid),zdq0(ngrid)
+      REAL zx_alf1(ngrid),zx_alf2(ngrid)
 
       LOGICAL firstcall
@@ -103,5 +101,5 @@
 !     variables added for CO2 condensation
 !     ------------------------------------
-      REAL hh                   !, zhcond(ngridmx,nlayermx)
+      REAL hh                   !, zhcond(ngrid,nlayermx)
 !     REAL latcond,tcond1mb
 !     REAL acond,bcond
@@ -112,8 +110,8 @@
 !     -------
       INTEGER iq
-      REAL zq(ngridmx,nlayermx,nqmx)
-      REAL zq1temp(ngridmx)
-      REAL rho(ngridmx)         ! near-surface air density
-      REAL qsat(ngridmx)
+      REAL zq(ngrid,nlayermx,nq)
+      REAL zq1temp(ngrid)
+      REAL rho(ngrid)         ! near-surface air density
+      REAL qsat(ngrid)
       DATA firstcall/.true./
       REAL kmixmin
@@ -121,11 +119,11 @@
 !     Variables added for implicit latent heat inclusion
 !     --------------------------------------------------
-      real latconst, dqsat(ngridmx), qsat_temp1, qsat_temp2
-      real z1_Tdry(ngridmx), z2_Tdry(ngridmx)
-      real z1_T(ngridmx), z2_T(ngridmx)
-      real zb_T(ngridmx)
-      real zc_T(ngridmx,nlayermx)
-      real zd_T(ngridmx,nlayermx)
-      real lat1(ngridmx), lat2(ngridmx)
+      real latconst, dqsat(ngrid), qsat_temp1, qsat_temp2
+      real z1_Tdry(ngrid), z2_Tdry(ngrid)
+      real z1_T(ngrid), z2_T(ngrid)
+      real zb_T(ngrid)
+      real zc_T(ngrid,nlayermx)
+      real zd_T(ngrid,nlayermx)
+      real lat1(ngrid), lat2(ngrid)
       real surfh2otot
       logical surffluxdiag
@@ -152,11 +150,4 @@
 
       IF (firstcall) THEN
-!         IF(ngrid.NE.ngridmx) THEN
-!            PRINT*,'STOP dans vdifc'
-!            PRINT*,'probleme de dimensions :'
-!            PRINT*,'ngrid  =',ngrid
-!            PRINT*,'ngridmx  =',ngridmx
-!            STOP
-!         ENDIF
 !     To compute: Tcond= 1./(bcond-acond*log(.0095*p)) (p in pascal)
 !     bcond=1./tcond1mb
@@ -254,5 +245,5 @@
 !     ------------------------------------------------------ 
 
-      call vdif_kc(ptimestep,g,pzlev,pzlay
+      call vdif_kc(ngrid,ptimestep,g,pzlev,pzlay
      &     ,pu,pv,ph,zcdv_true
      &     ,pq2,zkv,zkh)
@@ -442,5 +433,5 @@
 !     Calculate vertical flux from the bottom to the first layer (dust)
 !     -----------------------------------------------------------------
-         do ig=1,ngridmx  
+         do ig=1,ngrid  
             rho(ig) = zb0(ig,1) /ptimestep
          end do
Index: trunk/LMDZ.GENERIC/libf/phystd/vlz_fi.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/vlz_fi.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/vlz_fi.F	(revision 787)
@@ -35,5 +35,5 @@
 c
 
-      real dzq(ngridmx,llm),dzqw(ngridmx,llm),adzqw(ngridmx,llm),dzqmax
+      real dzq(ngrid,llm),dzqw(ngrid,llm),adzqw(ngrid,llm),dzqmax
       real newmasse
       real sigw, Mtot, MQtot
@@ -90,5 +90,5 @@
 
        do l = 1,llm          ! loop different than when w<0
-        do  ij = 1,ngrid
+        do ij=1,ngrid
 
          if(w(ij,l).gt.0.)then
@@ -133,10 +133,10 @@
 
 c      Surface flux up:
-       do  ij = 1,ngrid
+       do ij=1,ngrid
          if(w(ij,1).lt.0.) wq(ij,1)=0. ! warning : not always valid
        end do
 
        do l = 1,llm-1  ! loop different than when w>0
-        do  ij = 1,ngrid
+        do ij=1,ngrid
          if(w(ij,l+1).le.0)then
 
Index: trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F	(revision 787)
@@ -39,4 +39,6 @@
 !
 !=================================================================
+
+      USE surfdat_h
  
       implicit none
@@ -52,5 +54,4 @@
 #include "netcdf.inc"
 #include "temps.h"
-#include "surfdat.h"
 
 ! Arguments on input:
@@ -95,6 +96,5 @@
       character(len=20),save :: nom_def(n_nom_def_max)
       logical,save :: firstcall=.true.
-      
-#ifndef MESOSCALE
+
 !***************************************************************
 !Sortie des variables au rythme voulu
@@ -108,4 +108,6 @@
 !***************************************************************
 
+#ifndef NOWRITEDIAGFI
+
 ! At very first call, check if there is a "diagfi.def" to use and read it
 ! -----------------------------------------------------------------------
@@ -113,5 +115,5 @@
          firstcall=.false.
 
-  !      Open diagfi.def definition file if there is one:
+!      Open diagfi.def definition file if there is one:
          open(99,file="diagfi.def",status='old',form='formatted',
      s   iostat=ierr2)
@@ -192,5 +194,5 @@
       endif ! if (firstnom.eq.'1234567890')
 
-      if (ngridmx.eq.1) then
+      if (ngrid.eq.1) then
         ! in testphys1d, for the 1d version of the GCM, iphysiq and irythme
         ! are undefined; so set them to 1
@@ -448,3 +450,4 @@
 
 #endif
+
       end
